﻿using System;

namespace TestProject
{
    /// <summary>
    /// 커스텀 색상
    /// </summary>
    public struct CustomColor
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 적색
        /// </summary>
        public short Red;

        /// <summary>
        /// 녹색
        /// </summary>
        public short Green;

        /// <summary>
        /// 청색
        /// </summary>
        public short Blue;

        /// <summary>
        /// 알파
        /// </summary>
        public short Alpha;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 밝게하기 - Brighten(value)

        /// <summary>
        /// 밝게하기
        /// </summary>
        /// <param name="value">값</param>
        public void Brighten(short value)
        {
            Red   = (short)Math.Min(short.MaxValue, (int)Red   + value);
            Green = (short)Math.Min(short.MaxValue, (int)Green + value);
            Blue  = (short)Math.Min(short.MaxValue, (int)Blue  + value);
            Alpha = (short)Math.Min(short.MaxValue, (int)Alpha + value);
        }

        #endregion
    }
}